]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Lazily load `pip` completion
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60 if test -n "$BASH_VERSION"; then
61    [ "`type -t ls`" = alias ] && unalias ls
62    [ "`type -t ll`" = alias ] && unalias ll
63    [ "`type -t mc`" = alias ] && unalias mc
64
65    back() { cd - "$@"; }
66    functions() { typeset -f "$@"; }
67    j() { jobs; }
68
69    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
70       if [ -d /usr/share/bash-completion -a -r /usr/share/bash-completion/bash_completion ]; then
71          _BASH_COMPLETIONS_DIR=/usr/share/bash-completion/completions
72          . /usr/share/bash-completion/bash_completion
73       elif [ -r /etc/bash_completion ]; then
74          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
75          . /etc/bash_completion
76       elif [ -d /etc/bash_completion.d ]; then
77          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
78          for _compf in /etc/bash_completion.d/*; do
79             . $_compf
80          done
81       elif [ -d /usr/local/etc/bash_completion.d ]; then
82          _BASH_COMPLETIONS_DIR=/usr/local/etc/bash_completion.d
83          for _compf in /usr/local/etc/bash_completion.d/*; do
84             . $_compf
85          done
86       else
87          echo "Unknown OS type, cannot source bash_completion" >&2
88       fi
89    fi
90
91    has_completion() {
92       [ -n "$_BASH_COMPLETIONS_DIR" -a -d "$_BASH_COMPLETIONS_DIR" -a -r "$_BASH_COMPLETIONS_DIR/$1" ] ||
93       complete -p $1 >/dev/null 2>&1
94    }
95
96    for cmd in builtin cgmem_nice command dbus-launch exec \
97          killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg \
98          run-hosts su sudo time whence whereis which xargs; do
99       ! has_completion $cmd && complete -o default -A command $cmd
100    done
101
102    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 \
103          ssh2 s2 socat telnet t tt \
104          tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
105          whois wd wget wget-download wget-m wget-wrapper ww; do
106       ! has_completion $cmd && complete -A hostname $cmd
107    done
108
109    for cmd in distribute ftp lftp r rsync \
110          s scp ssh smbclient tcpdump tshark wireshark; do
111       ! has_completion $cmd && complete -o default -A hostname $cmd
112    done
113
114    for cmd in bg fg jobs; do
115       ! has_completion $cmd && complete -A job $cmd
116    done
117
118    complete -A job j wait
119
120    for cmd in unset; do
121       ! has_completion $cmd && complete -A function -A variable $cmd
122    done
123
124    if [ -d "$HOME"/.bash_completion.d ]; then
125       for _compf in "$HOME"/.bash_completion.d/*; do
126          . $_compf
127       done
128    fi
129
130    delegate_completion() {
131       local prog programs
132       prog=$1
133       ! has_completion $prog && return
134       shift
135       programs="$@"
136       eval "_${prog}_completion_loader() {
137          _completion_loader $prog
138          if [ x"$DELEGARE_NOSPACE" = x1 ]; then
139             complete -o nospace -F _$prog $programs
140          else
141             complete -F _$prog $programs
142          fi
143          unset _${prog}_completion_loader
144          return 124
145       }"
146       complete -F _${prog}_completion_loader $programs
147    }
148
149    delegate_completion make m
150    delegate_completion ping p
151    delegate_completion python python2.7 python3.4 python3.5 python3.6 python3.7 python3.8 python3.9
152    DELEGARE_NOSPACE=1 delegate_completion rsync r rsync_cgmn rsync_cgmn_recode rsync_cgmn_recode2
153    delegate_completion ssh s
154    delegate_completion wget wget-m wget-wrapper ww
155
156    unset _BASH_COMPLETIONS_DIR has_completion delegate_completion
157
158    if [ -d "$HOME/lib/config" ]; then
159       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
160    fi
161    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
162
163    if [ "`type -t short_curdir`" != function -a \
164          -r "$HOME"/admin/prog/bash_prompt ]; then
165       . "$HOME"/admin/prog/bash_prompt
166    fi
167
168    if type -p pip >/dev/null 2>&1 || type -p pip3 >/dev/null 2>&1; then
169       _pip_completion_loader() {
170          eval "`pip$PY_VER completion --bash`"
171          complete -F _pip_completion pip pip2 pip2.7 pip3 pip3.4 pip3.5 pip3.6 pip3.7 pip3.8 pip3.9
172          unset _pip_completion_loader
173          return 124
174       }
175       complete -F _pip_completion_loader pip pip2 pip2.7 pip3 pip3.4 pip3.5 pip3.6 pip3.7 pip3.8 pip3.9
176    fi
177
178    #if which pyenv >/dev/null 2>&1; then
179    #   eval "`pyenv init -`"
180    #   eval "`pyenv virtualenv-init -`"
181    #fi
182
183    . virtualenvwrapper_lazy.sh 2>/dev/null
184
185    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
186       . "$VIRTUAL_ENV/bin/activate"
187    fi
188
189    # Clean up python virtual environment on exit
190    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
191
192    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
193
194 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
195    back() { cd - "$@"; }
196    j() { jobs; }
197 fi
198
199 PS1="$OPS1"
200
201 # clear screen and history, logout
202 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
203
204
205 if test -x /usr/bin/git >/dev/null 2>&1; then
206    # chdir to a directory
207    cdgitpath() {
208       if [ $# -ne 1 ]; then
209          echo "Usage: cdgitpath path_key" >&2
210          return 1
211       fi
212
213       path_key="$1"
214       if [ -z "$path_key" ]; then
215          echo "Usage: cdgitpath path_key" >&2
216          return 1
217       fi
218
219       path_url="`git config --get --path $path_key`"
220       if echo "$path_url" | grep -q '^file:/'; then
221          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
222       fi
223       cd "$path_url"
224    }
225
226    # chdir to a remote's directory (if the remote is on the local FS)
227    cdremote() {
228       if [ $# -gt 1 ]; then
229          echo "Usage: cdremote [remote_name]" >&2
230          return 1
231       fi
232
233       if [ -z "$1" ]; then
234          branch="`git rev-parse --abbrev-ref HEAD`"
235          remote="`git config --get branch.$branch.remote`"
236       else
237          remote="$1"
238       fi
239
240       if [ -n "$remote" ] && git config --get remote.$remote.url |
241             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
242          cdgitpath remote.$remote.url
243       else
244
245          if [ -n "$1" ]; then
246             echo "Cannot find directory for remote $1" >&2
247             echo "Usage: cdremote [remote_name]" >&2
248             return 1
249          fi
250
251          if test -n "$BASH_VERSION"; then
252             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
253             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
254                remote=${GIT_REMOTES[0]}
255                unset GIT_REMOTES
256                cdgitpath remote.$remote.url
257             else
258                unset GIT_REMOTES
259                echo "Cannot find directory for any remote" >&2
260                echo "Usage: cdremote [remote_name]" >&2
261                return 1
262             fi
263          else
264             echo "Cannot find directory for remote $1" >&2
265             echo "Usage: cdremote [remote_name]" >&2
266             return 1
267          fi
268       fi
269    }
270
271    if test -n "$BASH_VERSION"; then
272       # completion for aliases in global .gitconfig
273
274       # fixup rbi rbia rbiap rbip - do refs name completion
275       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
276       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
277       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
278       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
279       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
280       #
281       # push-to-all-remotes - do branch name completion
282       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
283
284       _cdgitpath_complete() {
285          local cur="${COMP_WORDS[COMP_CWORD]}"
286          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
287       }
288
289       _git_open() {
290          _cdgitpath_complete
291       }
292
293       complete -F _cdgitpath_complete cdgitpath git-open
294
295       # list remotes with URLs matching a regexp
296       _list_remotes() {
297          if [ $# -ne 1 ]; then
298             echo "Usage: _list_remotes remote_regexp" >&2
299             return 1
300          fi
301          declare -ag GIT_REMOTES=()
302          local remote
303          for remote in `git remote`; do
304             if git config --get remote.$remote.url | grep -q "$1"; then
305                GIT_REMOTES+=($remote)
306             fi
307          done
308       }
309
310       # completion for cdremote and git-open-remote - list remotes with a pattern
311       _list_remotes_completion() {
312          local cur="${COMP_WORDS[COMP_CWORD]}"
313          _list_remotes "$1"
314          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
315          unset GIT_REMOTES
316       }
317
318       # completion for cdremote - list remotes with directories as URLs
319       _cdremote_complete() {
320          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
321          if [ ${#COMPREPLY[*]} -eq 0 ]; then
322             _list_remotes_completion .
323          fi
324       }
325
326       complete -F _cdremote_complete cdremote
327
328       # completion for git-open-remote - list remotes with http(s) URLs
329       _git_open_remote() {
330          _list_remotes_completion '^http\(s\)\?://'
331          if [ ${#COMPREPLY[*]} -eq 0 ]; then
332             _list_remotes_completion .
333          fi
334       }
335
336       complete -F _git_open_remote git-open-remote
337    fi
338 fi
339
340
341 include() {
342    cfg="$1"
343    shift
344    if [ -f "./$cfg" -a -r "./$cfg" ]; then
345       echo "Reading config file \`$cfg'" 1>&2
346       . "./$cfg" "$@"
347    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
348       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
349       . "$HOME/lib/config/$cfg" "$@"
350    else
351       echo "Cannot find config file \`$cfg'" 1>&2
352    fi
353 }
354
355
356 mc() {
357    if test -n "$BASH_VERSION"; then
358       MC_SAVE_OPS1="$OPS1"
359       if [ "`type -t short_curdir`" = function ]; then
360          OPS1="\`cgmem_which_prompt\`\u@\${HOSTNAME::5}:\`short_curdir\`"
361          if test -x /usr/bin/git >/dev/null 2>&1; then
362             #if [ "`type -t __git_ps1`" = function ]; then
363             #   OPS1+="\$(__git_ps1)"
364             #else
365                OPS1+="\$(prompt_git)"
366             #fi
367          fi
368          OPS1+=" \$SHLVL\\$ "
369       else
370          OPS1="\u@\h:\W \$SHLVL\\$ "
371       fi
372    fi
373
374    if [ -n "$SLOWTERM" ]; then
375       MC_SLOW="--slow"
376    fi
377
378    case "$TERM" in
379       screen*) # screen, screen.rxvt
380          MC_XTERM="-x"
381       ;;
382    esac
383
384    #TMPDIR="$HOME"/tmp
385    #export TMPDIR
386
387    MC_FOUND=NO
388
389    for wrapper in \
390          /usr/local/share/mc/bin/mc-wrapper.sh \
391          /usr/local/libexec/mc/mc-wrapper.sh \
392          /usr/share/mc/bin/mc-wrapper.sh; do
393       if [ -r $wrapper ]; then
394          . $wrapper $MC_SLOW $MC_XTERM "$@"
395          rc=$?
396          MC_FOUND=YES
397          break
398       fi
399    done
400
401    if [ $MC_FOUND = NO ]; then
402       for mc in /usr/local/bin/mc /usr/bin/mc; do
403          if [ -x $mc ]; then
404             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
405             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
406                MC_TMP_DIR="${TMPDIR-/tmp}"
407             fi
408             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
409             mc_type="`mc_type.py $mc`"
410             if [ "$mc_type" = old ]; then
411                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
412             elif [ "$mc_type" = new ]; then
413                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
414             else
415                continue
416             fi
417             rc=$?
418             MC_FOUND=YES
419             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
420             break
421          fi
422       done
423    fi
424
425    if [ $MC_FOUND = NO ]; then
426       echo "Cannot find mc-wrapper.sh or mc" >&2
427       rc=1
428    fi
429
430    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
431    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
432
433    return $rc
434 }
435
436
437 mkcd() {
438    if [ $# -ne 1 ]; then
439       echo "Usage: mkcd directory_name" >&2
440    elif [ -d "$1" ]; then
441       cd "$1"
442    elif [ -e "$1" ]; then
443       echo "Error: $1 is a file" >&2
444    else
445       mkdir -p "$1" && cd "$1"
446    fi
447 }
448
449
450 if which tmux >/dev/null 2>&1; then
451    tmux() {
452       case "$TERM" in
453          rxvt)
454             TERM=rxvt-unicode command tmux "$@"
455          ;;
456
457          *)
458             command tmux "$@"
459          ;;
460       esac
461    }
462 fi
463
464
465 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
466    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
467 fi
468
469 x() { exit; }